> For the complete documentation index, see [llms.txt](https://docs.zama.org/tfhe-rs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zama.org/tfhe-rs/get-started/benchmarks/cpu/cpu-programmable-bootstrapping.md).

# Programmable bootstrapping

This document details the CPU performance benchmarks of programmable bootstrapping and keyswitch operations using **TFHE-rs**.

{% hint style="info" %}
All CPU benchmarks were launched on an `AWS hpc8a.96xlarge` instance equipped with two 96-core `AMD EPYC 9R45 CPU @ 2.30GHz` and 768GB of RAM.
{% endhint %}

The next tables show the execution time of a single programmable bootstrapping as well as keyswitch followed by a programmable bootstrapping depending on the precision of the input message. The associated parameters set are given. The configuration is tfhe-fft + AVX-512.

Note that these benchmarks use T-Uniform parameters. `MB-PBS` stands for multi-bit programmable bootstrapping with a grouping factor set to 4.

## P-fail: $$2^{-64}$$

![](https://2311470316-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FVsXygEQKbuBnXU0JLsUI%2Fuploads%2Fgit-blob-1f44baba0d7c7cf31f7a879c7360ac36911f8be4%2Fcpu-pbs-benchmark-tuniform-2m64.svg?alt=media)

## P-fail: $$2^{-128}$$

![](https://2311470316-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FVsXygEQKbuBnXU0JLsUI%2Fuploads%2Fgit-blob-b45e1538346a68e4d331e7268d1332fbef679d24%2Fcpu-pbs-benchmark-tuniform-2m128.svg?alt=media)

## Reproducing TFHE-rs benchmarks

**TFHE-rs** benchmarks can be easily reproduced from the [source](https://github.com/zama-ai/tfhe-rs).

{% hint style="info" %}
AVX512 is now enabled by default for benchmarks when available
{% endhint %}

The following example shows how to reproduce **TFHE-rs** benchmarks:

```shell
#PBS benchmarks:
make bench_pbs

#KS-PBS benchmarks:
make bench_ks_pbs
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.zama.org/tfhe-rs/get-started/benchmarks/cpu/cpu-programmable-bootstrapping.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
